//+------------------------------------------------------------------+
//|Trail Strength_TrendStopExpert.mq4 this EA is no more than        |
//|the trail stop function grabbing from  TrendStrengthExpert_v2.mq4 |
//|Copyright  2007, TrendLaboratory Ltd                             |
//|                                     TrendStrengthExpert_v2.mq4   |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>

//---- input parameters
extern string     Expert_Name    = "TrendStrengthExpert_v2";

//extern int        Magic          = 20202;    // if Magic=0 then AutoMagic
extern int        Slippage       =     3;

extern string     Main_data      = " Trade Volume & Trade Method";


extern double     TakeProfit     =     0;    // Take Profit Value in pips 
extern double     StopLoss       =     0;    // Initial Stop Value in pips
extern int        TrailingMode   =     3;    // 0-off,1-standard,2-System by TE  
extern double     TrailingStop   =     0;    // Trailing Stop Value in pips
extern double     MoneyRisk      =     0.5;    // Deviation of VoltyChannel_Stop or MoneyRisk
extern double     BreakEven      =     0;    // Break-Even Value in pips
extern double     ProfitLock     =     0;    // Profit Lock in pips

extern string     Time_Inputs    = " Timing parameters ";
extern int        StartHour      =     0;    // Start Hour of Trade Session 
extern int        StartMinute    =     0;    // Start Minute of Trade Session 
extern int        EndHour        =    23;    // End Hour of Trade Session
extern int        EndMinute      =     0;    // End Hour of Trade Session
extern int        CloseTimeMode  =     0;    // CloseTime mode: 0-off,1-on
extern int        CloseHour      =    24;    // Trade Close Hour   
extern int        CloseMinute    =     0;    // Trade Close Minute   

extern string     TE_Inputs      = " TrendEnvelope parameters";
extern int        TE_TimeFrame   =     0;    // Time Frame in min
extern int        TE_MAPeriod    =    10;    // Period of Moving Average
extern int        TE_MAMode      =     0;    // Method of MA Calculation
extern int        TE_CurBar      =     1;    // Shift relative to the current bar
extern int        TE_Mode        =     0;    // TE Mode: 0-off,1-trend(confirmation),2-signal*/

extern string     VS_Inputs      = " VoltyChannel_Stop parameters";
extern int        VS_TimeFrame   =     0;    // Time Frame in min
extern int        VS_Price       =     0;    // Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
extern int        VS_MALength    =     1;    // MA's Period 
extern int        VS_MAMode      =     0;    // MA's Method:0-SMA,1-EMA,2-SMMA,3-LWMA  
extern int        VS_ATRLength   =    10;    // ATR's Period
extern double     VS_Kv          =     3;    // Volatility's Factor or Multiplier
extern int        VS_CurBar      =     1;    // Shift relative to the current bar
extern int        VS_Mode        =     0;    // VS Mode: 0-off,1-trend(confirmation),2-signal


int      OrderBar=0;
int      BEvent=0, TriesNum=5;
datetime CurrBar,PrevBar;
double   UpLine, DnLine;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   
   CurrBar = iTime(Symbol(),0,0);
   PrevBar = iTime(Symbol(),0,1);

   return(0);
}
//----
// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP) 
   numords++;
   }
   return(numords);
}  



void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol()) 
      {
         if (mode==OP_BUY) 
         {
			   if ( BreakEven > 0 && BEvent==0 )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+ProfitLock*Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+ProfitLock*Point,Digits);
			      BEvent=1;
			      }
			   }
			   else 			   
			   if( TrailingMode==1 && TrailingStop > 0 ) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*Point,Digits);
			   else
			   if( (TrailingMode==2 || TrailingMode==3) && UpLine>0) BuyStop = NormalizeDouble(UpLine,Digits);
			   
			 if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }          
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if ( BreakEven > 0 && BEvent==0)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/Point;
			   
			      if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-ProfitLock*Point || OrderStopLoss()== 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-ProfitLock*Point,Digits);
			      BEvent=-1;
			      }
			   }
			   else 
			   if (TrailingMode==1 && TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*Point,Digits);   
            else
            if( (TrailingMode==2 || TrailingMode==3) && DnLine>0) SellStop = NormalizeDouble(DnLine,Digits);
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) 
             {
               if( SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   	      }	    
         }
      }
   }     
}





//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   
   
  if(iBars(Symbol(),VS_TimeFrame) < 100 || IsTradeAllowed()==false) return(0); 
      
  
   CurrBar = iTime(Symbol(),0,0);
   
   datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
   
   
   
   if (CurrBar != PrevBar)
   {
      if(TrailingMode==3)
      {
      UpLine  = iCustom(Symbol(),VS_TimeFrame,"VoltyChannel_Stop_v2.1",VS_Price,VS_MALength,VS_MAMode,VS_ATRLength,VS_Kv,MoneyRisk,0,0,0,VS_CurBar);
      DnLine  = iCustom(Symbol(),VS_TimeFrame,"VoltyChannel_Stop_v2.1",VS_Price,VS_MALength,VS_MAMode,VS_ATRLength,VS_Kv,MoneyRisk,0,0,1,VS_CurBar);
      }
      else
      if(TrailingMode==2)
      {
      UpLine  = iCustom(Symbol(),TE_TimeFrame,"TrendEnvelopes_v2",TE_MAPeriod,TE_MAMode,0,0,0,TE_CurBar);
      DnLine  = iCustom(Symbol(),TE_TimeFrame,"TrendEnvelopes_v2",TE_MAPeriod,TE_MAMode,0,0,1,TE_CurBar);
      }      
      
   
  
   //else
     if(ScanTrades()>0)
     {
     if(BreakEven > 0 || TrailingMode>0) TrailStop();
     }
     PrevBar = CurrBar;
   }
//----}
   return(0);
} 


